e23ce51135dbed9ff8fc7e51984dfc417311b835
[mes.git] / build-aux / check-mescc.sh
1 #! /bin/sh
2
3 # Mes --- Maxwell Equations of Software
4 # Copyright © 2017,2018 Jan (janneke) Nieuwenhuizen <janneke@gnu.org>
5 #
6 # This file is part of Mes.
7 #
8 # Mes is free software; you can redistribute it and/or modify it
9 # under the terms of the GNU General Public License as published by
10 # the Free Software Foundation; either version 3 of the License, or (at
11 # your option) any later version.
12 #
13 # Mes is distributed in the hope that it will be useful, but
14 # WITHOUT ANY WARRANTY; without even the implied warranty of
15 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
16 # GNU General Public License for more details.
17 #
18 # You should have received a copy of the GNU General Public License
19 # along with Mes.  If not, see <http://www.gnu.org/licenses/>.
20
21 if [ -n "$BUILD_DEBUG" ]; then
22     set -x
23 fi
24
25 export BLOOD_ELF GUILE HEX2 M1 MES MESCC
26 export M1FLAGS HEX2FLAGS PREPROCESS
27 export MES_ARENA MES_PREFIX MES_SEED
28 export BUILD_DEBUG
29 export LIBC CC32LIBS MESCCLIBS
30
31 MES=${MES-src/mes}
32 MESCC=${MESCC-scripts/mescc}
33 GUILE=${GUILE-guile}
34 MES_PREFIX=${MES_PREFIX-.}
35
36 HEX2=${HEX2-hex2}
37 M1=${M1-M1}
38 BLOOD_ELF=${BLOOD_ELF-blood-elf}
39 MES_SEED=${MES_SEED-../mes-seed}
40 MESCC=${MESCC-$(command -v mescc)}
41 [ -z "$MESCC" ] && MESCC=scripts/mescc
42 MES=${MES-$(command -v mes)}
43 [ -z "$MES" ] && MES=src/mes
44
45 if ! command -v $GUILE > /dev/null; then
46     GUILE=true
47 fi
48
49 tests="
50 t
51 00-exit-0
52 01-return-0
53 02-return-1
54 03-call
55 04-call-0
56 05-call-1
57 06-call-!1
58 10-if-0
59 11-if-1
60 12-if-==
61 13-if-!=
62 14-if-goto
63 15-if-!f
64 16-if-t
65 20-while
66 21-char[]
67 22-while-char[]
68 23-pointer
69 30-strlen
70 31-eputs
71 32-compare
72 33-and-or
73 34-pre-post
74 35-compare-char
75 36-compare-arithmetic
76 37-compare-assign
77 38-compare-call
78 40-if-else
79 41-?
80 42-goto-label
81 43-for-do-while
82 44-switch
83 45-void-call
84 46-function-static
85 47-function-expression
86 48-function-destruct
87 49-global-static
88 4a-char-array
89 50-assert
90 51-strcmp
91 52-itoa
92 53-strcpy
93 54-argv
94 60-math
95 61-array
96 62-array
97 63-struct-cell
98 64-make-cell
99 65-read
100 70-printf
101 71-struct-array
102 72-typedef-struct-def
103 73-union
104 74-multi-line-string
105 75-struct-union
106 76-pointer-arithmetic
107 77-pointer-assign
108 78-union-struct
109 79-int-array
110 7a-struct-char-array
111 7b-struct-int-array
112 7c-dynarray
113 7d-cast-char
114 7e-struct-array-access
115 7f-struct-pointer-arithmetic
116 7g-struct-byte-word-field
117 7h-struct-assign
118 7i-struct-struct
119 7j-strtoull
120 7k-for-each-elem
121 7l-struct-any-size-array
122 7m-struct-char-array-assign
123 7n-struct-struct-array
124 7o-struct-pre-post
125 7p-struct-cast
126 7q-bit-field
127 7r-sign-extend
128 7s-struct-short
129 80-setjmp
130 81-qsort
131 82-define
132 83-heterogenoous-init
133 84-struct-field-list
134 85-sizeof
135 86-strncpy
136 87-sscanf
137 90-strpbrk
138 91-fseek
139 92-stat
140 93-fread-fwrite
141 94-unsetenv
142 95-signal
143 96-strto
144 "
145
146 # 90: needs GNU, fails for mescc, passes for tcc
147 broken="$broken
148 7s-struct-short
149 "
150
151 # gcc not supported
152 CC=
153 set +e
154 expect=$(echo $broken | wc -w)
155 pass=0
156 fail=0
157 total=0
158 for t in $tests; do
159     if [ -z "${t/[012][0-9]-*/}" ]; then
160         LIBC=c-mini
161         MESCCLIBS="-l c-mini"
162     elif [ -z "${t/[78][0-9a-z]-*/}" ]; then
163         LIBC=c+tcc
164         MESCCLIBS="-l c+tcc"
165     elif [ -z "${t/9[0-9]-*/}" ]; then
166         LIBC=c+gnu
167         MESCCLIBS="-l c+gnu"
168     else
169         LIBC=c
170         MESCCLIBS=
171     fi
172     sh build-aux/test.sh "scaffold/tests/$t" &> scaffold/tests/"$t".log
173     r=$?
174     total=$((total+1))
175     if [ $r = 0 ]; then
176         echo $t: [OK]
177         pass=$((pass+1))
178     else
179         echo $t: [FAIL]
180         fail=$((fail+1))
181     fi
182 done
183
184 tests="
185 00_assignment
186 01_comment
187 02_printf
188 03_struct
189 04_for
190 05_array
191 06_case
192 07_function
193 08_while
194 09_do_while
195
196 10_pointer
197 11_precedence
198 12_hashdefine
199 13_integer_literals
200 14_if
201 15_recursion
202 16_nesting
203 17_enum
204 18_include
205 19_pointer_arithmetic
206
207 20_pointer_comparison
208 21_char_array
209 22_floating_point
210 23_type_coercion
211 24_math_library
212 25_quicksort
213 26_character_constants
214 27_sizeof
215 28_strings
216 29_array_address
217
218 30_hanoi
219 31_args
220 32_led
221 33_ternary_op
222 34_array_assignment
223 35_sizeof
224 36_array_initialisers
225 37_sprintf
226 38_multiple_array_index
227 39_typedef
228
229 40_stdio
230 41_hashif
231 42_function_pointer
232 43_void_param
233 44_scoped_declarations
234 45_empty_for
235 47_switch_return
236 48_nested_break
237 49_bracket_evaluation
238
239 50_logical_second_arg
240 51_static
241 52_unnamed_enum
242 54_goto
243 55_lshift_type
244 "
245
246 broken="$broken
247 18_include
248
249 22_floating_point
250 23_type_coercion
251 24_math_library
252 26_character_constants
253 27_sizeof
254 28_strings
255
256 34_array_assignment
257 39_typedef
258
259 40_stdio
260 42_function_pointer
261 49_bracket_evaluation
262 55_lshift_type
263 "
264
265 #22_floating_point       ; float
266 #23_type_coercion        ; float
267 #24_math_library         ; float
268 #27_sizeof               ; float
269 #28_strings              ; TODO: strncpy strchr strrchr memset memcpy memcmp
270 #30_hanoi                ; fails with GCC
271 #34_array_assignment     ; fails with GCC
272 #39_typedef              ;unsupported: (decl (decl-spec-list (stor-spec (typedef)) (type-spec (typename "MyFunStruct"))) (init-declr-list (init-declr (ptr-declr (pointer) (ident "MoreFunThanEver")))))
273
274 #40_stdio                ; f* functions
275 #42_function_pointer     ; f* functions
276 #49_bracket_evaluation   ; float
277
278 LIBC=c+gnu
279 MESCCLIBS="-l c+gnu"
280
281 expect=$(echo $broken | wc -w)
282 ARGS="arg1 arg2 arg3 arg4 arg5"
283 export ARGS
284 for t in $tests; do
285     if [ ! -f scaffold/tinycc/"$t.c" ]; then
286         echo ' [SKIP]'
287         continue;
288     fi
289     sh build-aux/test.sh "scaffold/tinycc/$t" &> scaffold/tinycc/"$t".log
290     r=$?
291     total=$((total+1))
292     if [ $r = 0 ]; then
293         echo $t: [OK]
294         pass=$((pass+1))
295     else
296         echo $t: [FAIL]
297         fail=$((fail+1))
298     fi
299 done
300 [ $expect != 0 ] && echo "expect: $expect"
301 [ $fail != 0 ] && echo "failed: $fail"
302 [ $fail -lt $expect ] && echo "solved: $(($expect - $fail))"
303 echo "passed: $pass"
304 echo "total:  $total"
305 if [ $fail != 0 -a $fail -gt $expect ]; then
306     echo FAILED: $fail/$total
307     exit 1
308 elif [ $fail != 0 ]; then
309     echo PASS: $pass/$total
310 else
311     echo PASS: $total
312 fi